﻿// Copyright (c) 2019 by E. Lücke

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using G_Api_Wrapper;


namespace G_Wrapper_Test
{
    class Program
    {
        static void Main(string[] args)
        {
            // Common variables

            String result_str = "";
            UInt32 portNumber = 0;
            StringBuilder interfaceName = new StringBuilder("CAN2");

            // CAN variables

            UInt32 id = 0x3C0;
            UInt16 cycleTime = 100;
            Byte sendState = 1;
            Byte group = 0;
            Byte msgCount = 0;
            Byte[] data = new Byte[64];
            Byte dlc = 4;
            Byte mode = 7;
            UInt32 bufferSize = 8168;
            UInt32 myBufferSize = 8168;
            UInt32 numberOfItems = 0;
            // Byte[] buffer = new Byte[8168];

            // Struct RampDefine
            GAPI_CAN.G_Can_CyclicMsgs_Ramp_Define_Parameters_t RampParameters = new GAPI_CAN.G_Can_CyclicMsgs_Ramp_Define_Parameters_t();
            // Struct BufferMonitor
            GAPI_CAN.G_Can_Monitor_BufferItem_t[] bufferItems = new GAPI_CAN.G_Can_Monitor_BufferItem_t[bufferSize];
                                
                     


            // get the version of the installed runtime

            UInt32 major = 0;
            UInt32 minor = 0;
            UInt32 revision = 0;
            if (GAPI.G_NO_ERROR != GAPI.Call_G_GetApiVersion(ref major, ref minor, ref revision)) {
                result_str = GAPI.Call_G_GetLastErrorDescription();
                Console.WriteLine(result_str);
            }

            // print the version

            Console.Write("This is GApi version: ");
            Console.Write(major);Console.Write('.');
            Console.Write(minor);Console.Write('.');
            Console.WriteLine(revision);


            // Common_OpenInterface

            if (GAPI.G_NO_ERROR != GAPI_Common.Call_G_Common_OpenInterface(interfaceName, ref portNumber))
            {
                result_str = GAPI.Call_G_GetLastErrorDescription();
                Console.WriteLine(result_str);
            }

            if (GAPI.G_NO_ERROR != GAPI_Common.Call_G_Common_InitInterface(portNumber))
            {
                result_str = GAPI.Call_G_GetLastErrorDescription();
                Console.WriteLine(result_str);
            }

            // Can_CyclicMsgs_DefineMsg

            data[0] = 0x00;
            data[1] = 0x00;
            data[2] = 0x02;
            data[3] = 0x00;
            data[4] = 0x00;
            data[5] = 0x00;
            data[6] = 0x00;
            data[7] = 0x00;

            if (GAPI.G_NO_ERROR != GAPI_CAN.Call_G_Can_CyclicMsgs_DefineMsg(portNumber, id, cycleTime, sendState, group, msgCount, ref data[0], dlc))
            {
                result_str = GAPI.Call_G_GetLastErrorDescription();
                Console.WriteLine(result_str);
            }

            // Can_CyclicMsgs_Ramp_Define

            RampParameters.Id = 0x3C0;
            RampParameters.Signal.Size = 4;
            RampParameters.Signal.ByteOrder = 0;
            RampParameters.Signal.Offset = 8;
            RampParameters.Mode = 1;
            RampParameters.Direction = 1;
            RampParameters.MinValue = 0;
            RampParameters.MaxValue = 15;
            RampParameters.UpdateRate = 1;
            RampParameters.Increment = 1;
            RampParameters.RampSum = 0;
            RampParameters.NumberOfFlanks = 0;


            if (GAPI.G_NO_ERROR != GAPI_CAN.Call_G_Can_CyclicMsgs_Ramp_Define(portNumber, ref RampParameters))
            {
                result_str = GAPI.Call_G_GetLastErrorDescription();
                Console.WriteLine(result_str);
            }

            // G_Can_Monitor_BufferMode_Start

            if (GAPI.G_NO_ERROR != GAPI_CAN.Call_G_Can_Monitor_BufferMode_Start(portNumber, mode, bufferSize))
            {
                 result_str = GAPI.Call_G_GetLastErrorDescription();
                 Console.WriteLine(result_str);
             }

             Thread.Sleep(1000);

            // G_Can_Monitor_BufferMode_GetItems

            if (GAPI.G_NO_ERROR != GAPI_CAN.Call_G_Can_Monitor_BufferMode_GetItems(portNumber, myBufferSize, ref numberOfItems, ref bufferItems))
            {
                result_str = GAPI.Call_G_GetLastErrorDescription();
                Console.WriteLine(result_str);
            }
            else
            {
                for (UInt32 i = 0; i < numberOfItems; i++)
                {
                    Console.WriteLine(bufferItems[i]);
                }
            }

            // G_Can_Monitor_BufferMode_Stop

            if (GAPI.G_NO_ERROR != GAPI_CAN.Call_G_Can_Monitor_BufferMode_Stop(portNumber))
             {
                  result_str = GAPI.Call_G_GetLastErrorDescription();
                  Console.WriteLine(result_str);
             }       

              

            // Always last function!
            // Common_CloseInterface

            if (GAPI.G_NO_ERROR != GAPI_Common.Call_G_Common_CloseInterface(portNumber))
            {
                result_str = GAPI.Call_G_GetLastErrorDescription();
                Console.WriteLine(result_str);
            }

            Console.WriteLine(portNumber);

            Console.WriteLine("Fertig");
            Console.ReadKey();
        }
    }
}
